%global composer_vendor         eduvpn
%global composer_project        vpn-api-client
%global composer_namespace      SURFnet/VPN/ApiClient

%global github_owner            eduvpn
%global github_name             vpn-api-client
%global github_commit           a7047eb94489a0fdb7a3143fdc2c3449b96e7ef8
%global github_short            %(c=%{github_commit}; echo ${c:0:7})

Name:       vpn-api-client
Version:    1.0.0
Release:    0.12%{?dist}
Summary:    VPN API Client

Group:      Applications/Internet
License:    AGPLv3+

URL:        https://github.com/%{github_owner}/%{github_name}
Source0:    %{url}/archive/%{github_commit}/%{name}-%{version}-%{github_short}.tar.gz
Source1:    %{name}-httpd.conf

BuildArch:  noarch
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 

BuildRequires:  %{_bindir}/phpunit
BuildRequires:  php(language) >= 5.4.0
BuildRequires:  php-spl
BuildRequires:  php-libsodium
BuildRequires:  php-composer(twig/twig) < 2
BuildRequires:  php-composer(fkooman/oauth2-client)
BuildRequires:  php-composer(paragonie/constant_time_encoding)
BuildRequires:  php-composer(fedora/autoloader)

Requires:   php(language) >= 5.4.0
Requires:   php-spl
Requires:   php-libsodium
Requires:   php-composer(twig/twig) < 2
Requires:   php-composer(fkooman/oauth2-client)
Requires:   php-composer(paragonie/constant_time_encoding)
Requires:   php-composer(fedora/autoloader)
%if 0%{?fedora} >= 24
Requires:   httpd-filesystem
%else
# EL7 does not have httpd-filesystem
Requires:   httpd
%endif

Requires(post): /usr/sbin/semanage
Requires(postun): /usr/sbin/semanage

%description
VPN API Client.

%prep
%setup -qn %{github_name}-%{github_commit} 

sed -i "s|require_once sprintf('%s/vendor/autoload.php', dirname(__DIR__));|require_once '%{_datadir}/%{name}/src/%{composer_namespace}/autoload.php';|" web/*.php

%build
cat <<'AUTOLOAD' | tee src/autoload.php
<?php
require_once '%{_datadir}/php/Fedora/Autoloader/autoload.php';

\Fedora\Autoloader\Autoload::addPsr4('SURFnet\\VPN\\ApiClient\\', __DIR__);
\Fedora\Autoloader\Dependencies::required(array(
    '%{_datadir}/php/Twig/autoload.php',
    '%{_datadir}/php/fkooman/OAuth/Client/autoload.php',
    '%{_datadir}/php/ParagonIE/ConstantTime/autoload.php',
));
AUTOLOAD

%install
install -m 0644 -D -p %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

mkdir -p %{buildroot}%{_datadir}/%{name}
cp -pr web views %{buildroot}%{_datadir}/%{name}
mkdir -p %{buildroot}%{_datadir}/%{name}/src/%{composer_namespace}
cp -pr src/* %{buildroot}%{_datadir}/%{name}/src/%{composer_namespace}

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cp -pr config/config.php.example %{buildroot}%{_sysconfdir}/%{name}/config.php
ln -s ../../../etc/%{name} %{buildroot}%{_datadir}/%{name}/config

mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}
ln -s ../../../var/lib/%{name} %{buildroot}%{_datadir}/%{name}/data

%post
semanage fcontext -a -t httpd_sys_rw_content_t '%{_localstatedir}/lib/%{name}(/.*)?' 2>/dev/null || :
restorecon -R %{_localstatedir}/lib/%{name} || :

# remove template cache if it is there
rm -rf %{_localstatedir}/lib/%{name}/tpl/* >/dev/null 2>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then  # final removal
semanage fcontext -d -t httpd_sys_rw_content_t '%{_localstatedir}/lib/%{name}(/.*)?' 2>/dev/null || :
fi

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%dir %attr(0750,root,apache) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.php
%{_datadir}/%{name}/src
%{_datadir}/%{name}/web
%{_datadir}/%{name}/data
%{_datadir}/%{name}/views
%{_datadir}/%{name}/config
%dir %attr(0700,apache,apache) %{_localstatedir}/lib/%{name}
%doc README.md CHANGES.md composer.json config/config.php.example
%license LICENSE

%changelog
* Fri May 12 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.12
- rebuilt

* Thu May 11 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.11
- rebuilt

* Thu May 11 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.10
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.9
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.8
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.7
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.6
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.5
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.4
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.3
- rebuilt

* Wed May 10 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.2
- rebuilt

* Wed May 03 2017 François Kooman <fkooman@tuxed.net> - 1.0.0-0.1
- initial package
